diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-8.c b/gcc/testsuite/gcc.target/s390/hotpatch-8.c
index 8edcfcc..7681eda 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-8.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-8.c
@@ -1,7 +1,7 @@
 /* Functional tests for the function hotpatching feature.  */
 
 /* { dg-do compile } */
-/* { dg-options "-O3 -mesa -m31 -mhotpatch=0,3 --save-temps" } */
+/* { dg-options "-O3 -mesa -m31 -march=g5 -mhotpatch=0,3 --save-temps" } */
 
 #include <stdio.h>
 
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-9.c b/gcc/testsuite/gcc.target/s390/hotpatch-9.c
index 25b3771..cf38d3d 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-9.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-9.c
@@ -1,7 +1,7 @@
 /* Functional tests for the function hotpatching feature.  */
 
 /* { dg-do compile } */
-/* { dg-options "-O3 -mesa -m31 -mhotpatch=0,4 --save-temps" } */
+/* { dg-options "-O3 -mesa -m31 -march=g5 -mhotpatch=0,4 --save-temps" } */
 
 #include <stdio.h>
 
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-1.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-1.c
index d88e07e..ca47f6b 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-1.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-1.c
@@ -2,10 +2,4 @@
 
 /* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -mhotpatch=-1,0" } */
-
-int main (void)
-{
-  return 0;
-}
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
+/* { dg-error "arguments to .-mhotpatch=n,m. should be non-negative integers" "" { target *-*-* } 1 } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-10.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-10.c
index 7bbdc37..8b6441d 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-10.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-10.c
@@ -5,8 +5,6 @@
 
 __attribute__((hotpatch(0,0,0)))
 int main (void)
-{
+{/* { dg-error "wrong number of arguments specified" } */
   return 0;
 }
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-11.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-11.c
index df01230..36c0e22 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-11.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-11.c
@@ -3,10 +3,10 @@
 /* { dg-do compile } */
 /* { dg-options "-O3 -mzarch" } */
 
+int a;
+
 __attribute__((hotpatch(a,0)))
 int main (void)
-{
+{ /* { dg-error "attribute is not a comma separated pair of non-negative integer constants or too large" } */
   return 0;
 }
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-12.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-12.c
index d91e8fe..9b5fbd3 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-12.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-12.c
@@ -3,10 +3,10 @@
 /* { dg-do compile } */
 /* { dg-options "-O3 -mzarch" } */
 
+int a;
+
 __attribute__((hotpatch(0,a)))
 int main (void)
-{
+{ /* { dg-error "attribute is not a comma separated pair of non-negative integer constants or too large" } */
   return 0;
 }
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-13.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-13.c
index 72f13a0..a8752412 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-13.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-13.c
@@ -18,12 +18,12 @@ void hp2(void)
 
 __attribute__ ((hotpatch(1000001,1000000)))
 void hp3(void)
-{ /* { dg-error " requested 'hotpatch' attribute is not a comma separated pair" } */
+{ /* { dg-error " requested .hotpatch. attribute is not a comma separated pair" } */
   printf("hello, world!\n");
 }
 
 __attribute__ ((hotpatch(1000000,1000001)))
 void hp4(void)
-{ /* { dg-error " requested 'hotpatch' attribute is not a comma separated pair" } */
+{ /* { dg-error " requested .hotpatch. attribute is not a comma separated pair" } */
   printf("hello, world!\n");
 }
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-14.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-14.c
index f3343d3..0b5e674 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-14.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-14.c
@@ -8,4 +8,4 @@ viod main(void)
   return 0;
 }
 
-/* { dg-excess-errors "argument to '-mhotpatch=n,m' is too large" } */
+/* { dg-error "argument to .-mhotpatch=n,m. is too large" "" { target *-*-* } 1 } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-2.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-2.c
index 95820e4..78253f5 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-2.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-2.c
@@ -2,10 +2,4 @@
 
 /* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -mhotpatch=0,-1" } */
-
-int main (void)
-{
-  return 0;
-}
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
+/* { dg-error "arguments to .-mhotpatch=n,m. should be non-negative integers" "" { target *-*-* } 1 } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-3.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-3.c
index bbed975..6dde224 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-3.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-3.c
@@ -2,10 +2,4 @@
 
 /* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -mhotpatch=0" } */
-
-int main (void)
-{
-  return 0;
-}
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
+/* { dg-error "arguments to .-mhotpatch=n,m. should be non-negative integers" "" { target *-*-* } 1 } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-4.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-4.c
index 4d92659..fbb3083 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-4.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-4.c
@@ -2,10 +2,4 @@
 
 /* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -mhotpatch=0,0,0" } */
-
-int main (void)
-{
-  return 0;
-}
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
+/* { dg-error "arguments to .-mhotpatch=n,m. should be non-negative integers" "" { target *-*-* } 1 } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-5.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-5.c
index 46c9004..dc0ff67 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-5.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-5.c
@@ -2,10 +2,4 @@
 
 /* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -mhotpatch=a,0" } */
-
-int main (void)
-{
-  return 0;
-}
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
+/* { dg-error "arguments to .-mhotpatch=n,m. should be non-negative integers" "" { target *-*-* } 1 } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-6.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-6.c
index b28e205..d04045e 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-6.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-6.c
@@ -2,10 +2,4 @@
 
 /* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -mhotpatch=0,a" } */
-
-int main (void)
-{
-  return 0;
-}
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
+/* { dg-error "arguments to .-mhotpatch=n,m. should be non-negative integers" "" { target *-*-* } 1 } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-7.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-7.c
index 2080eb1..3505703 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-7.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-7.c
@@ -5,8 +5,6 @@
 
 __attribute__((hotpatch(-1,0)))
 int main (void)
-{
+{/* { dg-error "attribute is not a comma separated pair of non-negative integer constants or too large" } */
   return 0;
 }
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-8.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-8.c
index 46a38c8..fd35431 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-8.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-8.c
@@ -5,8 +5,6 @@
 
 __attribute__((hotpatch(0,-1)))
 int main (void)
-{
+{/* { dg-error "attribute is not a comma separated pair of non-negative integer constants or too large" } */
   return 0;
 }
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */
diff --git a/gcc/testsuite/gcc.target/s390/hotpatch-compile-9.c b/gcc/testsuite/gcc.target/s390/hotpatch-compile-9.c
index 24226eb..dcefbe4 100644
--- a/gcc/testsuite/gcc.target/s390/hotpatch-compile-9.c
+++ b/gcc/testsuite/gcc.target/s390/hotpatch-compile-9.c
@@ -5,8 +5,6 @@
 
 __attribute__((hotpatch(0)))
 int main (void)
-{
+{/* { dg-error "wrong number of arguments specified" } */
   return 0;
 }
-
-/* { dg-excess-errors "argument to '-mhotpatch=' should be a non-negative integer" } */